import HvSwitch from 'hyperview/src/components/hv-switch';
import { LOCAL_NAME } from 'hyperview/src/types';
import { getElements } from 'hyperview/test/helpers';

describe('HvSwitch', () => {
  describe('getFormInputValues', () => {
    let elements: Element[];
    beforeEach(() => {
      elements = getElements(
        `
          <doc xmlns="https://hyperview.org/hyperview">
            <screen>
              <body>
                <switch name="input1" value="on" />
                <switch name="input2" />
                <switch value="on" />
              </body>
            </screen>
          </doc>
        `,
        LOCAL_NAME.SWITCH,
      );
    });
    it('returns value attr of on', async () => {
      expect(HvSwitch.getFormInputValues(elements[0])).toEqual([
        ['input1', 'on'],
      ]);
    });
    it('returns empty string if no value attr', async () => {
      expect(HvSwitch.getFormInputValues(elements[1])).toEqual([
        ['input2', ''],
      ]);
    });

    it('returns empty array if no name attr', async () => {
      expect(HvSwitch.getFormInputValues(elements[2])).toEqual([]);
    });
  });
});
