var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _extends2=_interopRequireDefault(require("@babel/runtime/helpers/extends"));var _helpers=require("../../../test/helpers");var _=_interopRequireDefault(require("./"));var _types=require("../../types");describe('HvList',function(){describe('getItems',function(){var items;describe('simple list',function(){beforeEach(function(){var elements=(0,_helpers.getElements)("\n            <doc xmlns=\"https://hyperview.org/hyperview\">\n              <screen>\n                <body>\n                  <list>\n                    <item id=\"foo\"/>\n                    <item id=\"bar\"/>\n                    <item id=\"baz\"/>\n                  </list>\n                </body>\n              </screen>\n            </doc>\n          ",_types.LOCAL_NAME.LIST);var list=new _.default((0,_extends2.default)({},(0,_helpers.getDummyHvProps)(),{element:elements[0]}));items=list.getItems();});it('returns expected items count',function _callee(){return _regenerator.default.async(function _callee$(_context){while(1){switch(_context.prev=_context.next){case 0:expect(items.length).toEqual(3);case 1:case"end":return _context.stop();}}},null,null,null,Promise);});it('returns expected items order',function _callee2(){return _regenerator.default.async(function _callee2$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:expect(items[0].getAttribute('id')).toEqual('foo');expect(items[1].getAttribute('id')).toEqual('bar');expect(items[2].getAttribute('id')).toEqual('baz');case 3:case"end":return _context2.stop();}}},null,null,null,Promise);});});describe('nested lists',function(){var elements;beforeAll(function(){elements=(0,_helpers.getElements)("\n          <doc xmlns=\"https://hyperview.org/hyperview\">\n            <screen>\n              <body>\n                <list>\n                  <item id=\"foo\">\n                    <list>\n                      <item id=\"foo-foo\"/>\n                      <item id=\"foo-bar\"/>\n                    </list>\n                  </item>\n                  <item id=\"bar\"/>\n                  <item id=\"baz\"/>\n                </list>\n              </body>\n            </screen>\n          </doc>\n        ",_types.LOCAL_NAME.LIST);});describe('list 1',function(){beforeAll(function(){var list=new _.default((0,_extends2.default)({},(0,_helpers.getDummyHvProps)(),{element:elements[0]}));items=list.getItems();});it('returns expected items count',function _callee3(){return _regenerator.default.async(function _callee3$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:expect(items.length).toEqual(3);case 1:case"end":return _context3.stop();}}},null,null,null,Promise);});it('returns expected items order',function _callee4(){return _regenerator.default.async(function _callee4$(_context4){while(1){switch(_context4.prev=_context4.next){case 0:expect(items[0].getAttribute('id')).toEqual('foo');expect(items[1].getAttribute('id')).toEqual('bar');expect(items[2].getAttribute('id')).toEqual('baz');case 3:case"end":return _context4.stop();}}},null,null,null,Promise);});});describe('list 2',function(){beforeAll(function(){var list=new _.default((0,_extends2.default)({},(0,_helpers.getDummyHvProps)(),{element:elements[1]}));items=list.getItems();});it('returns expected items count',function _callee5(){return _regenerator.default.async(function _callee5$(_context5){while(1){switch(_context5.prev=_context5.next){case 0:expect(items.length).toEqual(2);case 1:case"end":return _context5.stop();}}},null,null,null,Promise);});it('returns expected items order',function _callee6(){return _regenerator.default.async(function _callee6$(_context6){while(1){switch(_context6.prev=_context6.next){case 0:expect(items[0].getAttribute('id')).toEqual('foo-foo');expect(items[1].getAttribute('id')).toEqual('foo-bar');case 2:case"end":return _context6.stop();}}},null,null,null,Promise);});});});describe('paginated lists',function(){var elements;beforeAll(function(){elements=(0,_helpers.getElements)("\n          <doc xmlns=\"https://hyperview.org/hyperview\">\n            <screen>\n              <body>\n                <list>\n                  <item id=\"foo\"/>\n                  <item id=\"bar\"/>\n                  <items>\n                    <item id=\"1-foo\"/>\n                    <item id=\"1-bar\"/>\n                    <item id=\"1-baz\"/>\n                    <items>\n                      <item id=\"2-foo\"/>\n                      <item id=\"2-bar\"/>\n                      <item id=\"2-baz\"/>\n                    </items>\n                  </items>\n                  <item id=\"baz\"/>\n                </list>\n              </body>\n            </screen>\n          </doc>\n        ",_types.LOCAL_NAME.LIST);var list=new _.default((0,_extends2.default)({},(0,_helpers.getDummyHvProps)(),{element:elements[0]}));items=list.getItems();});it('returns expected items count',function _callee7(){return _regenerator.default.async(function _callee7$(_context7){while(1){switch(_context7.prev=_context7.next){case 0:expect(items.length).toEqual(9);case 1:case"end":return _context7.stop();}}},null,null,null,Promise);});it('returns expected items order',function _callee8(){return _regenerator.default.async(function _callee8$(_context8){while(1){switch(_context8.prev=_context8.next){case 0:expect(items[0].getAttribute('id')).toEqual('foo');expect(items[1].getAttribute('id')).toEqual('bar');expect(items[2].getAttribute('id')).toEqual('1-foo');expect(items[3].getAttribute('id')).toEqual('1-bar');expect(items[4].getAttribute('id')).toEqual('1-baz');expect(items[5].getAttribute('id')).toEqual('2-foo');expect(items[6].getAttribute('id')).toEqual('2-bar');expect(items[7].getAttribute('id')).toEqual('2-baz');expect(items[8].getAttribute('id')).toEqual('baz');case 9:case"end":return _context8.stop();}}},null,null,null,Promise);});});describe('paginated and nested lists',function(){var elements;beforeAll(function(){elements=(0,_helpers.getElements)("\n          <doc xmlns=\"https://hyperview.org/hyperview\">\n            <screen>\n              <body>\n                <list>\n                  <item id=\"foo\"/>\n                  <item id=\"bar\">\n                    <list>\n                      <item id=\"bar-foo\"/>\n                      <item id=\"bar-bar\"/>\n                      <items>\n                        <item id=\"bar-1-foo\"/>\n                        <item id=\"bar-1-bar\"/>\n                        <item id=\"bar-1-baz\"/>\n                      </items>\n                      <item id=\"bar-baz\"/>\n                    </list>\n                  </item>\n                  <items>\n                    <item id=\"1-foo\"/>\n                    <item id=\"1-bar\"/>\n                    <item id=\"1-baz\">\n                      <list>\n                        <item id=\"1-baz-foo\"/>\n                        <item id=\"1-baz-bar\"/>\n                        <items>\n                          <item id=\"1-baz-1-foo\"/>\n                          <item id=\"1-baz-1-bar\"/>\n                        </items>\n                        <item id=\"1-baz-baz\"/>\n                      </list>\n                    </item>\n                  </items>\n                  <items>\n                    <item id=\"2-foo\"/>\n                    <item id=\"2-bar\"/>\n                    <item id=\"2-baz\"/>\n                  </items>\n                  <item id=\"baz\"/>\n                </list>\n              </body>\n            </screen>\n          </doc>\n        ",_types.LOCAL_NAME.LIST);var list=new _.default((0,_extends2.default)({},(0,_helpers.getDummyHvProps)(),{element:elements[0]}));items=list.getItems();});describe('list 1',function(){beforeAll(function(){var list=new _.default((0,_extends2.default)({},(0,_helpers.getDummyHvProps)(),{element:elements[0]}));items=list.getItems();});it('returns expected items count',function _callee9(){return _regenerator.default.async(function _callee9$(_context9){while(1){switch(_context9.prev=_context9.next){case 0:expect(items.length).toEqual(9);case 1:case"end":return _context9.stop();}}},null,null,null,Promise);});it('returns expected items order',function _callee10(){return _regenerator.default.async(function _callee10$(_context10){while(1){switch(_context10.prev=_context10.next){case 0:expect(items[0].getAttribute('id')).toEqual('foo');expect(items[1].getAttribute('id')).toEqual('bar');expect(items[2].getAttribute('id')).toEqual('1-foo');expect(items[3].getAttribute('id')).toEqual('1-bar');expect(items[4].getAttribute('id')).toEqual('1-baz');expect(items[5].getAttribute('id')).toEqual('2-foo');expect(items[6].getAttribute('id')).toEqual('2-bar');expect(items[7].getAttribute('id')).toEqual('2-baz');expect(items[8].getAttribute('id')).toEqual('baz');case 9:case"end":return _context10.stop();}}},null,null,null,Promise);});});describe('list 2',function(){beforeAll(function(){var list=new _.default((0,_extends2.default)({},(0,_helpers.getDummyHvProps)(),{element:elements[1]}));items=list.getItems();});it('returns expected items count',function _callee11(){return _regenerator.default.async(function _callee11$(_context11){while(1){switch(_context11.prev=_context11.next){case 0:expect(items.length).toEqual(6);case 1:case"end":return _context11.stop();}}},null,null,null,Promise);});it('returns expected items order',function _callee12(){return _regenerator.default.async(function _callee12$(_context12){while(1){switch(_context12.prev=_context12.next){case 0:expect(items[0].getAttribute('id')).toEqual('bar-foo');expect(items[1].getAttribute('id')).toEqual('bar-bar');expect(items[2].getAttribute('id')).toEqual('bar-1-foo');expect(items[3].getAttribute('id')).toEqual('bar-1-bar');expect(items[4].getAttribute('id')).toEqual('bar-1-baz');expect(items[5].getAttribute('id')).toEqual('bar-baz');case 6:case"end":return _context12.stop();}}},null,null,null,Promise);});});describe('list 3',function(){beforeAll(function(){var list=new _.default((0,_extends2.default)({},(0,_helpers.getDummyHvProps)(),{element:elements[2]}));items=list.getItems();});it('returns expected items count',function _callee13(){return _regenerator.default.async(function _callee13$(_context13){while(1){switch(_context13.prev=_context13.next){case 0:expect(items.length).toEqual(5);case 1:case"end":return _context13.stop();}}},null,null,null,Promise);});it('returns expected items order',function _callee14(){return _regenerator.default.async(function _callee14$(_context14){while(1){switch(_context14.prev=_context14.next){case 0:expect(items[0].getAttribute('id')).toEqual('1-baz-foo');expect(items[1].getAttribute('id')).toEqual('1-baz-bar');expect(items[2].getAttribute('id')).toEqual('1-baz-1-foo');expect(items[3].getAttribute('id')).toEqual('1-baz-1-bar');expect(items[4].getAttribute('id')).toEqual('1-baz-baz');case 5:case"end":return _context14.stop();}}},null,null,null,Promise);});});});});});