var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");var _interopRequireWildcard=require("@babel/runtime/helpers/interopRequireWildcard");var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var Dom=_interopRequireWildcard(require("./"));var UrlService=_interopRequireWildcard(require("../url"));var _types=require("./types");var _package=require("../../../package.json");var _this=this;var mockExpectedDocument={foo:'bar'};var mockParseFromString=jest.fn().mockReturnValue(mockExpectedDocument);jest.mock('@instawork/xmldom',function(){var DOMParser=function DOMParser(){return null;};DOMParser.prototype.parseFromString=function(){for(var _len=arguments.length,args=new Array(_len),_key=0;_key<_len;_key++){args[_key]=arguments[_key];}return mockParseFromString.apply(_this,args);};return{DOMParser:DOMParser};});var fetchMock=jest.fn();var responseTextMock=jest.fn();fetchMock.mockResolvedValue({text:responseTextMock});var beforeParseMock=jest.fn();var afterParseMock=jest.fn();var urlServiceAddFormDataToUrlMock=jest.spyOn(UrlService,'addFormDataToUrl');var parser=new Dom.Parser(fetchMock,beforeParseMock,afterParseMock);describe('Parser',function(){afterEach(function(){mockParseFromString.mockClear();fetchMock.mockClear();responseTextMock.mockClear();beforeParseMock.mockClear();afterParseMock.mockClear();urlServiceAddFormDataToUrlMock.mockClear();});describe('load',function(){describe('simple GET',function(){it('calls fetch with correct params',function _callee(){var url,expectedOptions,responseText,_await$parser$load,doc,staleHeaderType;return _regenerator.default.async(function _callee$(_context){while(1){switch(_context.prev=_context.next){case 0:url='http://foo/bar';expectedOptions={body:undefined,headers:{Accept:'application/xml, application/vnd.hyperview+xml','X-Hyperview-Dimensions':'750w 1334h','X-Hyperview-Version':_package.version},method:'get'};responseText='foobarbaz';responseTextMock.mockResolvedValue(responseText);_context.next=6;return _regenerator.default.awrap(parser.load(url));case 6:_await$parser$load=_context.sent;doc=_await$parser$load.doc;staleHeaderType=_await$parser$load.staleHeaderType;expect(urlServiceAddFormDataToUrlMock).toHaveBeenCalledTimes(0);expect(mockParseFromString).toHaveBeenCalledWith(responseText);expect(beforeParseMock).toHaveBeenCalledWith(url);expect(afterParseMock).toHaveBeenCalledWith(url);expect(fetchMock).toHaveBeenCalledWith(url,expectedOptions);expect(doc).toEqual(mockExpectedDocument);expect(staleHeaderType).toBeNull();case 16:case"end":return _context.stop();}}},null,null,null,Promise);});});describe('GET with data',function(){it('calls fetch with correct params',function _callee2(){var url,data,expectedUrl,responseText,_await$parser$load2,doc,staleHeaderType;return _regenerator.default.async(function _callee2$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:url='http://foo/bar';data=new FormData();data.append('foo','bar');data.append('bar','baz');expectedUrl='http://foo/bar?foo=bar&bar=baz';urlServiceAddFormDataToUrlMock.mockReturnValue(expectedUrl);responseText='foobarbaz';responseTextMock.mockResolvedValue(responseText);_context2.next=10;return _regenerator.default.awrap(parser.load(url,data));case 10:_await$parser$load2=_context2.sent;doc=_await$parser$load2.doc;staleHeaderType=_await$parser$load2.staleHeaderType;expect(urlServiceAddFormDataToUrlMock).toHaveBeenCalledWith(url,data);expect(mockParseFromString).toHaveBeenCalledWith(responseText);expect(beforeParseMock).toHaveBeenCalledWith(expectedUrl);expect(afterParseMock).toHaveBeenCalledWith(expectedUrl);expect(fetchMock).toHaveBeenCalledWith(expectedUrl,{body:undefined,headers:{Accept:'application/xml, application/vnd.hyperview+xml','X-Hyperview-Dimensions':'750w 1334h','X-Hyperview-Version':_package.version},method:'get'});expect(doc).toEqual(mockExpectedDocument);expect(staleHeaderType).toBeNull();case 20:case"end":return _context2.stop();}}},null,null,null,Promise);});});describe('offline GET',function(){it('sets the right staleHeaderType',function _callee3(){var url,expectedOptions,responseText,headers,_await$parser$load3,doc,staleHeaderType;return _regenerator.default.async(function _callee3$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:url='http://foo/bar';expectedOptions={body:undefined,headers:{Accept:'application/xml, application/vnd.hyperview+xml','X-Hyperview-Dimensions':'750w 1334h','X-Hyperview-Version':_package.version},method:'get'};responseText='foobarbaz';responseTextMock.mockResolvedValue(responseText);headers=new Map();headers.set(Dom.HTTP_HEADERS.X_RESPONSE_STALE_REASON,_types.X_RESPONSE_STALE_REASON.STALE_IF_ERROR);fetchMock.mockResolvedValueOnce({headers:headers,text:responseTextMock});_context3.next=9;return _regenerator.default.awrap(parser.load(url));case 9:_await$parser$load3=_context3.sent;doc=_await$parser$load3.doc;staleHeaderType=_await$parser$load3.staleHeaderType;expect(urlServiceAddFormDataToUrlMock).toHaveBeenCalledTimes(0);expect(mockParseFromString).toHaveBeenCalledWith(responseText);expect(beforeParseMock).toHaveBeenCalledWith(url);expect(afterParseMock).toHaveBeenCalledWith(url);expect(fetchMock).toHaveBeenCalledWith(url,expectedOptions);expect(doc).toEqual(mockExpectedDocument);expect(staleHeaderType).toEqual(_types.X_RESPONSE_STALE_REASON.STALE_IF_ERROR);case 19:case"end":return _context3.stop();}}},null,null,null,Promise);});});describe('POST',function(){it('calls fetch with correct params',function _callee4(){var url,data,responseText,_await$parser$load4,doc,staleHeaderType;return _regenerator.default.async(function _callee4$(_context4){while(1){switch(_context4.prev=_context4.next){case 0:url='http://foo/bar';data=new FormData();data.append('foo','bar');data.append('bar','baz');responseText='foobarbaz';responseTextMock.mockResolvedValue(responseText);_context4.next=8;return _regenerator.default.awrap(parser.load(url,data,'post'));case 8:_await$parser$load4=_context4.sent;doc=_await$parser$load4.doc;staleHeaderType=_await$parser$load4.staleHeaderType;expect(urlServiceAddFormDataToUrlMock).toHaveBeenCalledTimes(0);expect(mockParseFromString).toHaveBeenCalledWith(responseText);expect(beforeParseMock).toHaveBeenCalledWith(url);expect(afterParseMock).toHaveBeenCalledWith(url);expect(fetchMock).toHaveBeenCalledWith(url,{body:data,headers:{Accept:'application/xml, application/vnd.hyperview+xml','X-Hyperview-Dimensions':'750w 1334h','X-Hyperview-Version':_package.version},method:'post'});expect(doc).toEqual(mockExpectedDocument);expect(staleHeaderType).toBeNull();case 18:case"end":return _context4.stop();}}},null,null,null,Promise);});});});});