var _interopRequireWildcard=require("@babel/runtime/helpers/interopRequireWildcard");var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.Parser=void 0;var _regenerator=_interopRequireDefault(require("@babel/runtime/regenerator"));var _defineProperty2=_interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));var _classCallCheck2=_interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));var Errors=_interopRequireWildcard(require("./errors"));var UrlService=_interopRequireWildcard(require("../url"));var _types=require("./types");var _xmldom=require("@instawork/xmldom");var _reactNative=require("react-native");var _types2=require("../../types");var _helpers=require("./helpers");var _package=require("../../../package.json");var _Dimensions$get=_reactNative.Dimensions.get('window'),width=_Dimensions$get.width,height=_Dimensions$get.height;var parser=new _xmldom.DOMParser({errorHandler:{error:function error(_error){throw new Errors.XMLParserError(_error);},fatalError:function fatalError(error){throw new Errors.XMLParserFatalError(error);},warning:function warning(error){throw new Errors.XMLParserWarning(error);}},locator:{}});var Parser=function Parser(fetch,onBeforeParse,onAfterParse){var _this=this;(0,_classCallCheck2.default)(this,Parser);this.load=function _callee(baseUrl){var _headers,_response$headers,_response$headers2;var data,httpMethod,acceptContentType,method,url,options,response,responseText,contentType,staleHeaderType,doc,_args=arguments;return _regenerator.default.async(function _callee$(_context){while(1){switch(_context.prev=_context.next){case 0:data=_args.length>1&&_args[1]!==undefined?_args[1]:undefined;httpMethod=_args.length>2&&_args[2]!==undefined?_args[2]:undefined;acceptContentType=_args.length>3&&_args[3]!==undefined?_args[3]:_types.CONTENT_TYPE.APPLICATION_VND_HYPERVIEW_XML;method=httpMethod===_types.HTTP_METHODS.POST?_types.HTTP_METHODS.POST:_types.HTTP_METHODS.GET;url=method===_types.HTTP_METHODS.GET&&data?UrlService.addFormDataToUrl(baseUrl,data):baseUrl;options={body:method===_types.HTTP_METHODS.GET?undefined:data,headers:(_headers={},(0,_defineProperty2.default)(_headers,_types.HTTP_HEADERS.ACCEPT,_types.CONTENT_TYPE.APPLICATION_XML+", "+acceptContentType),(0,_defineProperty2.default)(_headers,_types.HTTP_HEADERS.X_HYPERVIEW_VERSION,_package.version),(0,_defineProperty2.default)(_headers,_types.HTTP_HEADERS.X_HYPERVIEW_DIMENSIONS,width+"w "+height+"h"),_headers),method:method};_context.next=8;return _regenerator.default.awrap(_this.fetch(url,options));case 8:response=_context.sent;_context.next=11;return _regenerator.default.awrap(response.text());case 11:responseText=_context.sent;contentType=(_response$headers=response.headers)==null?void 0:_response$headers.get(_types.HTTP_HEADERS.CONTENT_TYPE);staleHeaderType=(_response$headers2=response.headers)==null?void 0:_response$headers2.get(_types.HTTP_HEADERS.X_RESPONSE_STALE_REASON);if(!(response.status>=500&&staleHeaderType!==_types.X_RESPONSE_STALE_REASON.STALE_IF_ERROR&&contentType!==_types.CONTENT_TYPE.APPLICATION_XML)){_context.next=16;break;}throw new Errors.ServerError(url,responseText,response.headers,response.status);case 16:if(_this.onBeforeParse){_this.onBeforeParse(url);}doc=parser.parseFromString(responseText);if(_this.onAfterParse){_this.onAfterParse(url);}return _context.abrupt("return",{doc:doc,staleHeaderType:staleHeaderType||null});case 20:case"end":return _context.stop();}}},null,null,null,Promise);};this.loadDocument=function _callee2(baseUrl){var _await$_this$load,doc,staleHeaderType,docElement,screenElement,navigatorElement,bodyElement,routeElement;return _regenerator.default.async(function _callee2$(_context2){while(1){switch(_context2.prev=_context2.next){case 0:_context2.next=2;return _regenerator.default.awrap(_this.load(baseUrl));case 2:_await$_this$load=_context2.sent;doc=_await$_this$load.doc;staleHeaderType=_await$_this$load.staleHeaderType;docElement=(0,_helpers.getFirstTag)(doc,_types2.LOCAL_NAME.DOC);if(docElement){_context2.next=8;break;}throw new Errors.XMLRequiredElementNotFound(_types2.LOCAL_NAME.DOC,baseUrl);case 8:screenElement=(0,_helpers.getFirstTag)(docElement,_types2.LOCAL_NAME.SCREEN);navigatorElement=(0,_helpers.getFirstTag)(docElement,_types2.LOCAL_NAME.NAVIGATOR);if(!(!screenElement&&!navigatorElement)){_context2.next=12;break;}throw new Errors.XMLRequiredElementNotFound(_types2.LOCAL_NAME.SCREEN+"/"+_types2.LOCAL_NAME.NAVIGATOR,baseUrl);case 12:if(!screenElement){_context2.next=18;break;}bodyElement=(0,_helpers.getFirstTag)(screenElement,_types2.LOCAL_NAME.BODY);if(bodyElement){_context2.next=16;break;}throw new Errors.XMLRequiredElementNotFound(_types2.LOCAL_NAME.BODY,baseUrl);case 16:_context2.next=25;break;case 18:if(!navigatorElement){_context2.next=24;break;}routeElement=(0,_helpers.getFirstTag)(navigatorElement,_types2.LOCAL_NAME.NAV_ROUTE);if(routeElement){_context2.next=22;break;}throw new Errors.XMLRequiredElementNotFound(_types2.LOCAL_NAME.NAV_ROUTE,baseUrl);case 22:_context2.next=25;break;case 24:throw new Errors.XMLRequiredElementNotFound(_types2.LOCAL_NAME.SCREEN+"/"+_types2.LOCAL_NAME.NAVIGATOR,baseUrl);case 25:return _context2.abrupt("return",{doc:doc,staleHeaderType:staleHeaderType});case 26:case"end":return _context2.stop();}}},null,null,null,Promise);};this.loadElement=function _callee3(baseUrl,data){var method,_await$_this$load2,doc,staleHeaderType,docElement,navigatorElement,screenElement,bodyElement,_args3=arguments;return _regenerator.default.async(function _callee3$(_context3){while(1){switch(_context3.prev=_context3.next){case 0:method=_args3.length>2&&_args3[2]!==undefined?_args3[2]:_types.HTTP_METHODS.GET;_context3.next=3;return _regenerator.default.awrap(_this.load(baseUrl,data,method,_types.CONTENT_TYPE.APPLICATION_VND_HYPERVIEW_FRAGMENT_XML));case 3:_await$_this$load2=_context3.sent;doc=_await$_this$load2.doc;staleHeaderType=_await$_this$load2.staleHeaderType;docElement=(0,_helpers.getFirstTag)(doc,_types2.LOCAL_NAME.DOC);if(!docElement){_context3.next=9;break;}throw new Errors.XMLRestrictedElementFound(_types2.LOCAL_NAME.DOC,baseUrl);case 9:navigatorElement=(0,_helpers.getFirstTag)(doc,_types2.LOCAL_NAME.NAVIGATOR);if(!navigatorElement){_context3.next=12;break;}throw new Errors.XMLRestrictedElementFound(_types2.LOCAL_NAME.NAVIGATOR,baseUrl);case 12:screenElement=(0,_helpers.getFirstTag)(doc,_types2.LOCAL_NAME.SCREEN);if(!screenElement){_context3.next=15;break;}throw new Errors.XMLRestrictedElementFound(_types2.LOCAL_NAME.SCREEN,baseUrl);case 15:bodyElement=(0,_helpers.getFirstTag)(doc,_types2.LOCAL_NAME.BODY);if(!bodyElement){_context3.next=18;break;}throw new Errors.XMLRestrictedElementFound(_types2.LOCAL_NAME.BODY,baseUrl);case 18:return _context3.abrupt("return",{doc:doc,staleHeaderType:staleHeaderType});case 19:case"end":return _context3.stop();}}},null,null,null,Promise);};this.fetch=fetch;this.onBeforeParse=onBeforeParse;this.onAfterParse=onAfterParse;};exports.Parser=Parser;