var _interopRequireWildcard=require("@babel/runtime/helpers/interopRequireWildcard");var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.encodeXml=exports.getNameValueFormInputValues=exports.getFormData=exports.flattenRegistry=exports.getAncestorByTagName=exports.removeTimeoutId=exports.setTimeoutId=exports.getElementByTimeoutId=exports.shallowCloneToRoot=exports.shallowClone=exports.later=exports.createProps=exports.createTestProps=exports.createStyleProp=void 0;var _slicedToArray2=_interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));var _extends2=_interopRequireDefault(require("@babel/runtime/helpers/extends"));var Xml=_interopRequireWildcard(require("./xml"));var _types=require("./types");var _types2=require("../types");var _reactNative=require("react-native");var createStyleProp=function createStyleProp(element,stylesheets,options){var styleAttr=options.styleAttr||'style';if(!element.getAttribute(styleAttr)){return[];}var styleValue=element.getAttribute(styleAttr)||'';var styleIds=Xml.splitAttributeList(styleValue);var styleRules=styleIds.map(function(styleId){return stylesheets.regular[styleId];});if(options.pressed){var pressedRules=styleIds.map(function(styleId){return stylesheets.pressed[styleId];}).filter(Boolean);if(pressedRules.length===0){pressedRules=[{opacity:_types.DEFAULT_PRESS_OPACITY}];}styleRules=styleRules.concat(pressedRules);}if(options.focused){var focusedRules=styleIds.map(function(s){return stylesheets.focused[s];}).filter(Boolean);styleRules=styleRules.concat(focusedRules);}if(options.selected){var selectedRules=styleIds.map(function(s){return stylesheets.selected[s];}).filter(Boolean);styleRules=styleRules.concat(selectedRules);}if(options.pressedSelected){var pressedSelectedRules=styleIds.map(function(s){return stylesheets.pressedSelected[s];}).filter(Boolean);styleRules=styleRules.concat(pressedSelectedRules);}return styleRules;};exports.createStyleProp=createStyleProp;var createTestProps=function createTestProps(element){var testProps={};var id=element.getAttribute('id');if(!id){return testProps;}if(_reactNative.Platform.OS==='ios'){return{testID:id};}return{accessibilityLabel:id};};exports.createTestProps=createTestProps;var createProps=function createProps(element,stylesheets,options){var numericRules=['numberOfLines'];var booleanRules=['multiline','selectable','adjustsFontSizeToFit'];var props={};if(!element.attributes){return props;}for(var i=0;i<element.attributes.length;i+=1){var attr=element.attributes.item(i);if(attr){if(numericRules.indexOf(attr.name)>=0){var intValue=parseInt(attr.value,10);props[attr.name]=intValue||0;}else if(booleanRules.indexOf(attr.name)>=0){props[attr.name]=attr.value==='true';}else{props[attr.name]=attr.value;}}}props.style=createStyleProp(element,stylesheets,options);var testProps=createTestProps(element);return(0,_extends2.default)({},props,testProps);};exports.createProps=createProps;var later=function later(delayMs){return new Promise(function(resolve){return setTimeout(resolve,delayMs);});};exports.later=later;var shallowClone=function shallowClone(element){var newElement=element.cloneNode(false);var childNode=element.firstChild;while(childNode){var nextChild=childNode.nextSibling;newElement.appendChild(childNode);childNode=nextChild;}return newElement;};exports.shallowClone=shallowClone;var shallowCloneToRoot=function shallowCloneToRoot(element){var elementClone=shallowClone(element);if(element.nodeType===9){return elementClone;}var parentNode=element.parentNode;if(!parentNode){return elementClone;}parentNode.replaceChild(elementClone,element);return shallowCloneToRoot(parentNode);};exports.shallowCloneToRoot=shallowCloneToRoot;var visitNode=function visitNode(node,callback){if(callback(node)){return true;}var childNode=node.firstChild;while(childNode){if(visitNode(childNode,callback)){return true;}childNode=childNode.nextSibling;}return false;};var getElementByTimeoutId=function getElementByTimeoutId(doc,id){var foundElement=null;var callback=function callback(node){if(node.nodeType===_types2.NODE_TYPE.ELEMENT_NODE){var element=node;if(element.getAttribute(_types.HV_TIMEOUT_ID_ATTR)===id){foundElement=element;return true;}}return false;};visitNode(doc,callback);return foundElement;};exports.getElementByTimeoutId=getElementByTimeoutId;var setTimeoutId=function setTimeoutId(element,id){element.setAttribute(_types.HV_TIMEOUT_ID_ATTR,id);};exports.setTimeoutId=setTimeoutId;var removeTimeoutId=function removeTimeoutId(element){element.removeAttribute(_types.HV_TIMEOUT_ID_ATTR);};exports.removeTimeoutId=removeTimeoutId;var getAncestorByTagName=function getAncestorByTagName(element,tagName){var parentNode=element.parentNode;if(!parentNode){return null;}while(parentNode.tagName!==tagName){var _parentNode=parentNode;parentNode=_parentNode.parentNode;if(!parentNode){return null;}}return parentNode;};exports.getAncestorByTagName=getAncestorByTagName;var flattenRegistry=function flattenRegistry(registry){var entries=[];Object.keys(registry).forEach(function(ns){var nameRegistry=registry[ns];Object.keys(nameRegistry).forEach(function(name){var component=nameRegistry[name];entries.push([ns,name,component]);});});return entries;};exports.flattenRegistry=flattenRegistry;var getFormData=function getFormData(element,formComponents){var formElement=element.tagName==='form'?element:getAncestorByTagName(element,'form');if(!formElement){return null;}var formData=new FormData();var formHasData=false;flattenRegistry(formComponents).forEach(function(data){var _data=(0,_slicedToArray2.default)(data,3),ns=_data[0],tag=_data[1],component=_data[2];var inputElements=formElement.getElementsByTagNameNS(ns,tag);for(var i=0;i<inputElements.length;i+=1){var inputElement=inputElements.item(i);if(inputElement){var formComponent=component;formComponent.getFormInputValues(inputElement).forEach(function(_ref){var _ref2=(0,_slicedToArray2.default)(_ref,2),name=_ref2[0],value=_ref2[1];formData.append(name,value);formHasData=true;});}}});return formHasData?formData:null;};exports.getFormData=getFormData;var getNameValueFormInputValues=function getNameValueFormInputValues(element){var name=element.getAttribute('name');if(name){return[[name,element.getAttribute('value')||'']];}return[];};exports.getNameValueFormInputValues=getNameValueFormInputValues;var encodeXml=function encodeXml(xml){return xml.replace(/&/g,'&amp;').replace(/</g,'&lt;').replace(/>/g,'&gt;').replace(/"/g,'&quot;').replace(/'/g,'&apos;');};exports.encodeXml=encodeXml;