var _interopRequireWildcard=require("@babel/runtime/helpers/interopRequireWildcard");var _interopRequireDefault=require("@babel/runtime/helpers/interopRequireDefault");Object.defineProperty(exports,"__esModule",{value:true});exports.addStackRoute=exports.removeStackRoute=exports.setSelected=exports.mergeDocument=exports.buildRequest=exports.getNavAction=exports.getNavigatorById=exports.getRouteByUrl=exports.getRouteById=exports.getRouteId=exports.buildParams=exports.getNavigatorAndPath=exports.findPath=exports.validateUrl=exports.getUrlFromHref=exports.cleanHrefFragment=exports.isUrlFragment=exports.getSelectedNavRouteElement=exports.isNavigationElement=exports.getChildElements=exports.isModalRouteName=exports.isDynamicRoute=void 0;var _slicedToArray2=_interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));var _extends2=_interopRequireDefault(require("@babel/runtime/helpers/extends"));var _toConsumableArray2=_interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));var Errors=_interopRequireWildcard(require("./errors"));var Helpers=_interopRequireWildcard(require("../dom/helpers"));var Namespaces=_interopRequireWildcard(require("../namespaces"));var Types=_interopRequireWildcard(require("./types"));var UrlService=_interopRequireWildcard(require("../url"));var _types2=require("../../types");var _=require("./..");var isDynamicRoute=function isDynamicRoute(id){return id===Types.ID_CARD||id===Types.ID_MODAL;};exports.isDynamicRoute=isDynamicRoute;var isModalRouteName=function isModalRouteName(name){return name===Types.ID_MODAL;};exports.isModalRouteName=isModalRouteName;var getChildElements=function getChildElements(element){return(Array.from(element.childNodes)||[]).filter(function(child){return child.nodeType===_types2.NODE_TYPE.ELEMENT_NODE;});};exports.getChildElements=getChildElements;var isNavigationElement=function isNavigationElement(element){return element.namespaceURI===Namespaces.HYPERVIEW&&(element.localName===_types2.LOCAL_NAME.NAVIGATOR||element.localName===_types2.LOCAL_NAME.NAV_ROUTE);};exports.isNavigationElement=isNavigationElement;var getSelectedNavRouteElement=function getSelectedNavRouteElement(element){var elements=getChildElements(element).filter(function(child){return isNavigationElement(child);});if(!elements.length){return undefined;}var selectedChild=elements.find(function(child){return child.getAttribute(Types.KEY_SELECTED)==='true';});return selectedChild;};exports.getSelectedNavRouteElement=getSelectedNavRouteElement;var isUrlFragment=function isUrlFragment(url){return url.startsWith(Types.ANCHOR_ID_SEPARATOR);};exports.isUrlFragment=isUrlFragment;var cleanHrefFragment=function cleanHrefFragment(url){if(!isUrlFragment(url)){return url;}return url.slice(1);};exports.cleanHrefFragment=cleanHrefFragment;var getUrlFromHref=function getUrlFromHref(href,entrypointUrl){return UrlService.getUrlFromHref(cleanHrefFragment(href||''),entrypointUrl||'');};exports.getUrlFromHref=getUrlFromHref;var validateUrl=function validateUrl(action,routeParams){if(action===_types2.NAV_ACTIONS.PUSH||action===_types2.NAV_ACTIONS.NEW){if(!routeParams.url||!cleanHrefFragment(routeParams.url)){throw new Errors.HvNavigatorError("Route params must include a url for action '"+action+"'");}}};exports.validateUrl=validateUrl;var findPath=function findPath(state,targetId){var path=[];if(!state){return path;}if(!state.routes){return path;}state.routes.every(function(route){if(route.name===targetId){path.unshift(route.name);return false;}path=[].concat((0,_toConsumableArray2.default)(path),(0,_toConsumableArray2.default)(findPath(route.state,targetId)));if(path.length){path.unshift(route.name);return false;}return true;});return path;};exports.findPath=findPath;var getNavigatorAndPath=function getNavigatorAndPath(targetId,navigation){if(!targetId){return[navigation,undefined];}if(navigation){var path=findPath(navigation.getState(),targetId);if(path.length){return[navigation,path];}return getNavigatorAndPath(targetId,navigation.getParent());}return[undefined,undefined];};exports.getNavigatorAndPath=getNavigatorAndPath;var buildParams=function buildParams(routeId,path,routeParams){var index=arguments.length>3&&arguments[3]!==undefined?arguments[3]:0;if(path.length&&index<path.length){var screen=path[index];if(!screen){throw new Errors.HvNavigatorError('screen is undefined');}return{params:buildParams(routeId,path,routeParams,index+1),screen:screen};}return{params:routeParams,screen:routeId};};exports.buildParams=buildParams;var getRouteId=function getRouteId(action,url){if(url&&isUrlFragment(url)){return cleanHrefFragment(url);}return action===_types2.NAV_ACTIONS.NEW?Types.ID_MODAL:Types.ID_CARD;};exports.getRouteId=getRouteId;var getRouteById=function getRouteById(doc,id){var routes=Array.from(doc.getElementsByTagNameNS(Namespaces.HYPERVIEW,_types2.LOCAL_NAME.NAV_ROUTE)).filter(function(n){return n.getAttribute(Types.KEY_ID)===id;});return routes&&routes.length>0?routes[0]:undefined;};exports.getRouteById=getRouteById;var getRouteByUrl=function getRouteByUrl(doc,url,baseUrl){var routes=Array.from(doc.getElementsByTagNameNS(Namespaces.HYPERVIEW,_types2.LOCAL_NAME.NAV_ROUTE)).filter(function(n){return getUrlFromHref(n.getAttribute(Types.KEY_HREF),baseUrl)===getUrlFromHref(url,baseUrl);});return routes[0];};exports.getRouteByUrl=getRouteByUrl;var getNavigatorById=function getNavigatorById(doc,id){var navigators=Array.from(doc.getElementsByTagNameNS(Namespaces.HYPERVIEW,_types2.LOCAL_NAME.NAVIGATOR)).filter(function(n){return n.getAttribute(Types.KEY_ID)===id;});return navigators[0];};exports.getNavigatorById=getNavigatorById;var getNavAction=function getNavAction(action,routeParams){if(routeParams&&routeParams.url&&action===_types2.NAV_ACTIONS.PUSH&&isUrlFragment(routeParams.url)){return _types2.NAV_ACTIONS.NAVIGATE;}return action;};exports.getNavAction=getNavAction;var isRouteModal=function isRouteModal(state,index){if(!state||index>state.routes.length-1){return false;}return isModalRouteName(state.routes[index].name);};var buildCloseRequest=function buildCloseRequest(navigation,routeParams){if(!navigation){return[_types2.NAV_ACTIONS.CLOSE,navigation,'',routeParams];}var state=navigation.getState();if(state.type===Types.NAVIGATOR_TYPE.STACK){if(isRouteModal(state,state.index)){return[_types2.NAV_ACTIONS.CLOSE,navigation,'',routeParams];}for(var i=state.index;i>0;i-=1){if(isRouteModal(state,i)){var targetRoute=state.routes[i-1];return[_types2.NAV_ACTIONS.NAVIGATE,navigation,targetRoute.name,(0,_extends2.default)({},targetRoute.params,routeParams)];}}}var parent=navigation.getParent();if(!parent){return[_types2.NAV_ACTIONS.CLOSE,navigation,'',routeParams];}return buildCloseRequest(parent,routeParams);};var buildRequest=function buildRequest(nav,action,routeParams){var _routeParams$url;var navAction=getNavAction(action,routeParams);if(!routeParams){if(navAction===_types2.NAV_ACTIONS.CLOSE){return buildCloseRequest(nav,{});}return[navAction,nav,'',{}];}if(navAction===_types2.NAV_ACTIONS.BACK&&routeParams.url){return[navAction,nav,'',routeParams];}validateUrl(navAction,routeParams);var _getNavigatorAndPath=getNavigatorAndPath(routeParams.targetId||'',nav),_getNavigatorAndPath2=(0,_slicedToArray2.default)(_getNavigatorAndPath,2),navigation=_getNavigatorAndPath2[0],path=_getNavigatorAndPath2[1];var cleanedParams=(0,_extends2.default)({},routeParams);if(cleanedParams.url&&isUrlFragment(cleanedParams.url)){delete cleanedParams.url;}if(!navigation){return[navAction,undefined,'',cleanedParams];}var routeId=getRouteId(navAction,(_routeParams$url=routeParams.url)!=null?_routeParams$url:undefined);if(!path||!path.length){return[navAction,navigation,routeId,cleanedParams];}var lastPathId=path.shift();var params=buildParams(routeId,path,cleanedParams);return[navAction,navigation,lastPathId||routeId,params];};exports.buildRequest=buildRequest;var nodesToMap=function nodesToMap(nodes){var map={};if(!nodes){return map;}Array.from(nodes).forEach(function(node){if(node.nodeType===_types2.NODE_TYPE.ELEMENT_NODE){var element=node;if(isNavigationElement(element)){var id=element.getAttribute(Types.KEY_ID);if(id){map[id]=element;}}}});return map;};var mergeNodes=function mergeNodes(current,newNodes){if(!current||!current.childNodes||!newNodes||newNodes.length===0){return;}Array.from(current.childNodes).forEach(function(node){var element=node;if(isNavigationElement(element)){if(element.localName===_types2.LOCAL_NAME.NAVIGATOR){element.setAttribute(Types.KEY_MERGE,'false');}else if(element.localName===_types2.LOCAL_NAME.NAV_ROUTE){element.setAttribute(Types.KEY_SELECTED,'false');}}});var currentMap=nodesToMap(current.childNodes);Array.from(newNodes).forEach(function(node){if(node.nodeType===_types2.NODE_TYPE.ELEMENT_NODE){var newElement=node;if(isNavigationElement(newElement)){var id=newElement.getAttribute(Types.KEY_ID);if(id){var currentElement=currentMap[id];if(currentElement){if(newElement.localName===_types2.LOCAL_NAME.NAVIGATOR){var isMergeable=newElement.getAttribute(Types.KEY_MERGE)==='true'&&newElement.getAttribute(Types.KEY_TYPE)===currentElement.getAttribute(Types.KEY_TYPE);if(isMergeable){currentElement.setAttribute(Types.KEY_MERGE,'true');mergeNodes(currentElement,newElement.childNodes);}else{current.replaceChild(newElement,currentElement);}}else if(newElement.localName===_types2.LOCAL_NAME.NAV_ROUTE){currentElement.setAttribute(Types.KEY_SELECTED,newElement.getAttribute(Types.KEY_SELECTED)||'false');mergeNodes(currentElement,newElement.childNodes);}}else{current.appendChild(newElement);}}}}});};var mergeDocument=function mergeDocument(newDoc,currentDoc){if(!currentDoc){return newDoc;}if(!newDoc||!newDoc.childNodes){return currentDoc;}var newRoot=Helpers.getFirstTag(newDoc,_types2.LOCAL_NAME.DOC);if(!newRoot){throw new Errors.HvRouteError('No root element found in new document');}var currentRoot=Helpers.getFirstTag(currentDoc,_types2.LOCAL_NAME.DOC);if(!currentRoot){throw new Errors.HvRouteError('No root element found in current document');}var _getChildElements=getChildElements(newRoot),_getChildElements2=(0,_slicedToArray2.default)(_getChildElements,1),newElement=_getChildElements2[0];var _getChildElements3=getChildElements(currentRoot),_getChildElements4=(0,_slicedToArray2.default)(_getChildElements3,1),currentElement=_getChildElements4[0];if((currentElement==null?void 0:currentElement.localName)!==(newElement==null?void 0:newElement.localName)){return newDoc;}var composite=currentDoc.cloneNode(true);var compositeRoot=Helpers.getFirstTag(composite,_types2.LOCAL_NAME.DOC);if(!compositeRoot){throw new Errors.HvRouteError('No root element found in current document');}mergeNodes(compositeRoot,newRoot.childNodes);return composite;};exports.mergeDocument=mergeDocument;var setSelected=function setSelected(doc,id,setDoc){if(!doc||!id){return;}var route=getRouteById(doc,id);if(route&&route.parentNode){var parentNode=route.parentNode;var type=parentNode.getAttribute(Types.KEY_TYPE);if(type!==Types.NAVIGATOR_TYPE.TAB){return;}if(parentNode.childNodes){Array.from(parentNode.childNodes).forEach(function(child){var sibling=child;if(sibling&&sibling.localName===_types2.LOCAL_NAME.NAV_ROUTE){sibling.setAttribute(Types.KEY_SELECTED,'false');}});}route.setAttribute(Types.KEY_SELECTED,'true');}if(setDoc){var newRoot=(0,_.shallowCloneToRoot)(doc);setDoc(newRoot);}};exports.setSelected=setSelected;var removeStackRoute=function removeStackRoute(doc,url,baseUrl,setDoc){if(!doc||!url){return;}var route=getRouteByUrl(doc,url,baseUrl);if(route&&route.parentNode){var parentNode=route.parentNode;var type=parentNode.getAttribute(Types.KEY_TYPE);if(type===Types.NAVIGATOR_TYPE.STACK){if(getChildElements(parentNode).length>1){parentNode.removeChild(route);if(setDoc){var newRoot=(0,_.shallowCloneToRoot)(doc);setDoc(newRoot);}}}}};exports.removeStackRoute=removeStackRoute;var addStackRoute=function addStackRoute(doc,id,route,siblingName,baseUrl,setDoc){if(!doc||!id||!route||!siblingName||!isDynamicRoute(route.name)||!route.params.url||getRouteByUrl(doc,route.params.url,baseUrl)){return;}var siblingElement=getRouteById(doc,siblingName);if(siblingElement&&siblingElement.parentNode){var parentElement=siblingElement.parentNode;var type=parentElement.getAttribute(Types.KEY_TYPE);if(type===Types.NAVIGATOR_TYPE.STACK){var element=doc.createElementNS(Namespaces.HYPERVIEW,_types2.LOCAL_NAME.NAV_ROUTE);element.setAttribute(Types.KEY_ID,id);element.setAttribute(Types.KEY_HREF,route.params.url);parentElement.appendChild(element);if(setDoc){var newRoot=(0,_.shallowCloneToRoot)(doc);setDoc(newRoot);}}}};exports.addStackRoute=addStackRoute;